#
# forum-level access: show all the subjects of a particular
#                     forum.
# 
#
# Copyright (C) 1994 Afzal Ballim

############################################################
#
# WFCommandForum: display all of the subjects of a forum
#
sub WFCommandForum {
local (%in)=@_;

$userid=$ENV{REMOTE_USER};
if ($in{"forum"} eq "") {
    return "No Forum was selected.";
}
local ($forumdec) = &WFDecodeDatum($in{forum});
local ($forum)=$in{"forum"};
# get the list of subjects in the forums spool directory.
# the forums spool directory has subdirectories for each
# topic, with subsubdirectories for each user.
#
$thedir="ABSWFSPOOL/$forum";
opendir(DIR,$thedir)||return "$forum: No such forum could be found!";
@subject=readdir(DIR);
close(DIR);

#get the info for the directories
for (@subject) {
    next if $_ eq '.';
    next if $_ eq '..';
    # has it got a control file?
    if ($_ eq '.control') {
     if (!&WFUserAuthorised($userid,"ABSWFSPOOL/$forum/.control")) {
      return "You are not authorised to access $forumdec!
If you wish access permission, please contact CREATOR.";
     }
     next;
    }
    push(@subjects,$_);
}

# check to see if this has been called with a sort option
# CHANGED: if not set alphabetic by default
# TO: if not set mostrecent by default
# and back again...
if ($in{"sortmethod"} eq "") {
 $in{"sortmethod"}="alphabetic";
}

$thelist="";
if ($in{"sortmethod"} eq "alphabetic") {
    @subjects=sort @subjects;}
elsif ($in{"sortmethod"} eq "mostrecent") {
    @subjects=sort(WFForumstatbymostrecent @subjects);}

local ($fname,$fnamedec,$thelist,$sortmethod);
$sortmethod=$in{"sortmethod"};
foreach $fname (@subjects) {
   $fnamedec=&WFWrapHTMLCodes(&WFDecodeDatum($fname));
   $thelist = $thelist . <<EI
<li>
<form method="POST" action="STD_DOCOMMAND">
<input type="hidden" name="command" value="subject">
<input type="hidden" name="forum" value="$in{forum}">
<input type="hidden" name="subject" value="$fname">
<input type="hidden" name="sortmethod" value="$sortmethod">
<input type="submit" value="$fnamedec">
</form>
</li>
EI
}

if ($thelist eq "") {$thelist="<h2>No subjects in  $forumdec.</p></h2>";}

if ($in{"sortmethod"} eq "alphabetic") {
    &WFIncFile("ABSWFHTML/FORUM.HTML",
        THEFORUM,"$forumdec",
        ENCFORUM,"$in{forum}",
        SUBJECTLIST,"$thelist",
        SORTYPE,"$in{sortmethod}",
        ASORT,checked,
        MRCSORT,'') }
else {
    &WFIncFile("ABSWFHTML/FORUM.HTML",
        THEFORUM,"$forumdec",
        ENCFORUM,"$in{forum}",
        SUBJECTLIST,"$thelist",
        SORTYPE,"$in{sortmethod}",
        ASORT,'',
        MRCSORT,checked) }

return "";
}

sub WFForumstatbymostrecent {
 local (@d1) = stat("ABSWFSPOOL/$forum/$a");
 local (@d2) = stat("ABSWFSPOOL/$forum/$b");
 $d2[9] <=> $d1[9]; 
}

1;
