#
# adcommand: administration command
#
# Copyright (C) 1994 Afzal Ballim

require "ABSWFBIN/LIBWEBFORUM.PL";

# read the input from the form.
%in=&WFReadParse;

# The command is given via PATH_INFO or form variables.
# The PATH_INFO version takes precedence.

%pi=&WFDecodePathInfo;

if ($pi{"command"}) {
 $in{"command"}=$pi{"command"};
}

#let's get the easy bit out of the way: a header
&WFHtmlHeader;

# Now, let's process that command.
if (!$in{"command"}) { $in{"command"}="exit";}
#    &WFError(
#"<p>Something weird has happened and I can't find what
#command you gave me. Try contacting CREATOR.
#Useful information to include with your error message
#would be the command you <i>thought</i> you were
#calling.</p>
#<p><i>Note:</i> This may have been caused because you tried
#to reload the page. Unfortunately, these pages are not (currently)
#reload-able with the reader's reload function. You must instead
#click on the 'Rescan' button supplied with the pages.</p>");
#
#    exit;
#}
                
# The set of supported commands.
# Commands return a null string if they succeed, or an
# error message if they don't.
# When a command fails, we try another command if we can
# The onfail list is just a convenient table of command
# failure changes.
%onfail= ("updateusers","exit",
          "shownewreg","exit",
          "auxpost","exit",
          "addforum","exit",
          "deleteforum","exit",
          "showgroups","exit",
          "addgroup","exit",
          "deletegroup","exit",
          "showusers","exit",
          "adduser","exit",
          "deleteuser","exit",
          "group+user","exit",
          "group-user","exit",
          "showforumsgroups","exit",
          "forum+group","exit",
          "forum-group","exit");

	  
$CommandToDo=$in{"command"};

while ($CommandToDo ne "exit") {
 The_Commands: {
  $CommandToDo eq "" && &WFError("No Command!") && exit(1);

  $CommandToDo eq "updateusers" && do {
    require "ABSWFADMINBIN/ADM_UPDNR.PL";
    if (($WFCR=&WFCommandUpdateusers(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"updateusers"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "addforum" && do {
    require "ABSWFADMINBIN/ADM_ADDFORUM.PL";
    if (($WFCR=&WFCommandAddforum(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"addforum"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "deleteforum" && do {
    require "ABSWFADMINBIN/ADM_DELETEFORUM.PL";
    if (($WFCR=&WFCommandDeleteforum(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"deleteforum"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "showgroups" && do {
    require "ABSWFADMINBIN/ADM_SHOWGROUPS.PL";
    if (($WFCR=&WFCommandShowgroups(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"showgroups"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "addgroup" && do {
    require "ABSWFADMINBIN/ADM_ADDGROUP.PL";
    if (($WFCR=&WFCommandAddgroup(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"addgroup"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "deletegroup" && do {
    require "ABSWFADMINBIN/ADM_DELETEGROUP.PL";
    if (($WFCR=&WFCommandDeletegroup(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"deletegroup"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "showusers" && do {
    require "ABSWFADMINBIN/ADM_SHOWUSERS.PL";
    if (($WFCR=&WFCommandShowusers(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"showusers"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "adduser" && do {
    require "ABSWFADMINBIN/ADM_ADDUSER.PL";
    $in{group}="webforum";
    if (($WFCR=&WFCommandAdduser(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"adduser"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "deleteuser" && do {
    require "ABSWFADMINBIN/ADM_DELETEUSER.PL";
    if (($WFCR=&WFCommandDeleteuser(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"deleteuser"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "group+user" && do {
    require "ABSWFADMINBIN/ADM_GROUPPU.PL";
    if (($WFCR=&WFCommandGrpPU(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"group+user"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "group-user" && do {
    require "ABSWFADMINBIN/ADM_GROUPMU.PL";
    if (($WFCR=&WFCommandGroupMU(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"group-user"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "showforumsgroups" && do {
    require "ABSWFADMINBIN/ADM_SHOWFORUMSGROUPS.PL";
    if (($WFCR=&WFCommandShowforumsgroups(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"showforumsgroups"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "forum+group" && do {
    require "ABSWFADMINBIN/ADM_FORUMPG.PL";
    if (($WFCR=&WFCommandForumPG(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"forum+group"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "forum-group" && do {
    require "ABSWFADMINBIN/ADM_FORUMMG.PL";
    if (($WFCR=&WFCommandForumMG(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"forum-group"};last The_Commands;};
    $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "shownewreg" && do {
    require "ABSWFADMINBIN/ADM_SHOWNREG.PL";
    if (($WFCR=&WFCommandShownewreg(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"shownewreg"};last The_Commands;};
   $CommandToDo="exit";last The_Commands;};

  $CommandToDo eq "auxpost" && do {
    require "ABSWFADMINBIN/ADM_AUXPOST.PL";
    if (($WFCR=&WFCommandAuxPost(%in)) ne ""){
        &WFError($WFCR);
	$CommandToDo=$onfail{"auxpost"};last The_Commands;};
   $CommandToDo="exit";last The_Commands;};

#  $CommandToDo eq "" && do {
#    require "ABSWFADMINBIN/ADM_.PL";
#    if (($WFCR=&WFCommand(%in)) ne ""){
#        &WFError($WFCR);
#	$CommandToDo=$onfail{""};last The_Commands;};
#   $CommandToDo="exit";last The_Commands;};

  do {
    &WFError("Unknown or unimplemented command: $CommandToDo\n");
    $CommandToDo="exit";
  }
 }
}

&WFIncFile("ABSWFDBASE/ADMIN.HTML",
    'APOST',$in{"aux-post"},
    'APARGS',$in{"aux-post-args"},
    'THEUSER',$in{"theuser"},
    'THEFORUM',$in{"forum"},
    'THEGROUP',$in{"group"});
