#
# Update users: add new registrations to database
#
# Copyright (C) 1994 Afzal Ballim

############################################################
#
# WFCommandUpdateusers:
#
sub WFCommandUpdateusers {
 local (*users);
 local (*ausers);
 local (*groups);
 local ($user,$allusers);
 local (%uprof);

 @users=&WFListNewRegs;
 if ($#users == -1) {
  print "<em>No new registrations.</em><hr>";
  return "";
 }

 %ausers=&WFReadPasswdFile;
 %groups=&WFReadGroupFile;
 $allusers=join(' ',@users);

 if ($groups{"webforum"} eq "") {
     $groups{"webforum"}=$allusers;} 
 else {
     $groups{"webforum"}=$groups{"webforum"} . " $allusers";}
 foreach $user (@users) {
  %uprof=&WFReadDBFile($user);
  $ausers{$user}=$uprof{password};
 } 

 &WFWritePasswdFile(%ausers);
 &WFWriteGroupFile(%groups);
 print "<em>The following users have been added: $allusers</em><hr>";
 return "";
}

1;
